import fsmMgr

import math
import random

from OpenGL.GL import *
from OpenGL.GLU import *
import pygame, pygame.image
from pygame.locals import *

import mouseInfo
import stateFlight
import statePower
import tutorialProgress
import playerMgr
import level1
import textDraw
import stateAim
import stateTotalScore
import levelIntros
import stateDialog
import stateMainMenu

NUM_DISPLAYED=10

TITLE_SIZE=8
CLICK_MSG="Click To Continue."
CLICK_MSG_SIZE=4

SCORE_SIZE=5
SCORE_SPACE=24

class StateLevelScore(fsmMgr.State):
    def __init__(self, data):
        fsmMgr.State.__init__(self)

        self.clicked=False
        self.dialogTime=0.0

        self.scoreList=[]

    def init(self):
        levelNum=level1.thisLevel.level
        
        for p in playerMgr.gPlayerList:
            levelScore=p.scores[levelNum]
            totalScore=0
            for levelIndex in p.scores:
                totalScore += p.scores[levelIndex]

            self.scoreList.append((levelScore,totalScore,p.name))
        self.scoreList.sort()

        for s in self.scoreList:
            print s
            
    def update(self, dt):
        pass


    def handleMouseButton(self, bDown, buttonIndex):
        if bDown==True and buttonIndex==1:
            self.clicked=True

        if bDown==False and buttonIndex==1 and self.clicked:
            fsmMgr.popState()
        return True


    def draw(self):
        textDraw.drawCenteredString(400,550,
                                    (.25, 1, .25),
                                    TITLE_SIZE,
                                    "LEVEL RESULTS")

        y=500

        textDraw.drawString(100,y,
                            (.25,1,.25),
                            SCORE_SIZE,
                            "NAME~~~~~~~~~~~~~~~LEVEL~SCORE~~~~~TOTAL")

        y-=SCORE_SPACE*1.5



        for i,s in enumerate(self.scoreList):
            levelScore,totalScore,name=s

            nameLen=len(name)
            levelScoreString=str(levelScore)
            totalScoreString=str(totalScore)
            levelScoreLen=len(levelScoreString)
            totalScoreLen=len(totalScoreString)

            msg=name+"~"*(30-nameLen-levelScoreLen)
            msg+=levelScoreString+"~"*(10-totalScoreLen)
            msg+=totalScoreString
            
            textDraw.drawString(100,y,
                                (.25,1,.25),
                                SCORE_SIZE,
                                msg)

            y-=SCORE_SPACE


        textDraw.drawCenteredString(400,50,
                                    (.25, 1, .25),
                                    CLICK_MSG_SIZE,
                                    CLICK_MSG)
        
        
    def handleMouseButton(self, bDown, buttonIndex):
        #calibrate power next

        if bDown==True and buttonIndex==1:
            self.clicked=True
        if bDown==False and buttonIndex==1 and self.clicked:
            self.done()
        return True

    def handleKey(self, key):
        self.done()
        return True

    def done(self):
        fsmMgr.popState()
        specialLevel=self.parent.nextLevel()
        if specialLevel is None:
            fsmMgr.pushState(stateAim.StateAim(None))
            introText=levelIntros.intros.get(self.parent.level,None)
            if introText:
                if tutorialProgress.gTutorial:
                    title="Memo from Mr. Tigerbaum"
                else:
                    title="Level %2d"%(self.parent.level-9)
                    
                fsmMgr.pushState(stateDialog.StateDialog((title,introText)))
                
                    
        else:
            if tutorialProgress.gTutorial:
                fsmMgr.popAll()
                fsmMgr.pushState(stateMainMenu.StateMainMenu(None))
            else:
                fsmMgr.pushState(stateTotalScore.StateTotalScore(None))
